'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TYPES = ['text'];

var Input = function (_React$Component) {
    _inherits(Input, _React$Component);

    function Input(props) {
        var _Object$getPrototypeO;

        _classCallCheck(this, Input);

        var state = {};
        state.value = props.value;

        var _this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Input)).call.apply(_Object$getPrototypeO, [this].concat(_toConsumableArray(props))));

        _this._onMouseEnter = _this._onMouseEnter.bind(_this);
        _this._onMouseLeave = _this._onMouseLeave.bind(_this);
        _this._onChange = _this._onChange.bind(_this);

        _this.state = state;
        return _this;
    }

    _createClass(Input, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (this.state.value != prevState.value) {
                this.props.changeCallback();
            }
        }
    }, {
        key: '_onChange',
        value: function _onChange(e) {
            var value = e.target.value;
            if (value == this.state.value) return;

            this.setState({
                value: value
            });
        }
    }, {
        key: '_onMouseEnter',
        value: function _onMouseEnter(e) {
            this.props.mouseEnterCallback();
        }
    }, {
        key: '_onMouseLeave',
        value: function _onMouseLeave(e) {
            this.props.mouseLeaveCallback();
        }
    }, {
        key: 'render',
        value: function render() {
            var classes = "validate " + this.props.extraClass;
            return _react2.default.createElement(
                'div',
                { className: 'input-field col s12' },
                _react2.default.createElement('input', { placeholder: this.props.placeholder,
                    id: this.props.id,
                    type: this.props.type,
                    name: this.props.name,
                    onChange: this._onChange,
                    onMouseEnter: this._onMouseEnter,
                    onMouseLeave: this._onMouseLeave,
                    className: classes }),
                _react2.default.createElement('label', { htmlFor: this.props.id, dangerouslySetInnerHTML: { __html: this.props.label } })
            );
        }
    }]);

    return Input;
}(_react2.default.Component);

exports.default = Input;


Input.displayName = "GenericInputElement";
Input.propTypes = {
    required: _react2.default.PropTypes.bool,
    value: _react2.default.PropTypes.string,
    name: _react2.default.PropTypes.string,
    label: _react2.default.PropTypes.string,
    placeholder: _react2.default.PropTypes.string,
    id: _react2.default.PropTypes.string,
    type: _react2.default.PropTypes.oneOf(TYPES),
    extraClass: _react2.default.PropTypes.string,
    changeCallback: _react2.default.PropTypes.func,
    mouseEnterCallback: _react2.default.PropTypes.func,
    mouseLeaveCallback: _react2.default.PropTypes.func
};
Input.defaultProps = {
    required: false,
    value: '',
    name: '',
    label: '',
    placeholder: '',
    id: '',
    type: 'text',
    extraClass: '',
    changeCallback: function changeCallback() {},
    mouseEnterCallback: function mouseEnterCallback() {},
    mouseLeaveCallback: function mouseLeaveCallback() {}
};
//# sourceMappingURL=input.js.map
